SW = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0")

SW:RegisterChatCommand({ "/sw" }, {
	type = 'group',
	args = {
		elemental = {
			name = "Elemental Devastation",
			desc = "Toggles on/off Elemental Devastation warning",
			type = 'toggle',
			get = "IsElemental",
			set = "ToggleElemental",
		},
		windfury = {
			name = "WindFury",
			desc = "Toggles on/off WindFury warning",
			type = 'toggle',
			get = "IsWindfury",
			set = "ToggleWindfury",
		},
		flurry = {
			name = "Flurry",
			desc = "Toggles on/off Flurry warning",
			type = 'toggle',
			get = "IsFlurry",
			set = "ToggleFlurry",
		},
		storm = {
			name = "Eye of the Storm",
			desc = "Toggles on/off Eye of the Storm warning",
			type = 'toggle',
			get = "IsStorm",
			set = "ToggleStorm",
		},
		water = {
			name = "Water Shield",
			desc = "Toggles on/off Water Shield warning",
			type = 'toggle',
			get = "IsWater",
			set = "ToggleWater",
		},
		clearcast = {
			name = "Clearcasting",
			desc = "Toggles on/off clearcasting warning",
			type = 'toggle',
			get = "IsClearcast",
			set = "ToggleClearcast",
		},
	},
})

SW:RegisterDB("ShamanWarningDB")
SW:RegisterDefaults("profile", {
	elemental = true,
	windfury = true,
	flurry = true,
	storm = true,
	water = true,
	clearcast = true,
})

function SW:OnEnable()
	self:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS");
	self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	self:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_SELF");
end

function SW:CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS()
	if string.find(arg1,"Elemental Devastation") then
		if self.db.profile.elemental then PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Elemental.mp3") end;
	end
	if string.find(arg1,"Flurry") or string.find(arg1,"Unleashed Rage") then
		if self.db.profile.flurry then PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Flurry.mp3") end;
	end
	if string.find(arg1,"Focused Casting") then
		if self.db.profile.storm then PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Storm.mp3") end;
	end
	if string.find(arg1,"Clearcast") then
		if self.db.profile.clearcast then PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Clearcast.mp3") end;
	end
end

function SW:CHAT_MSG_SPELL_SELF_DAMAGE()
	if string.find(arg1,"Windfury") then
		if self.db.profile.windfury then PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\WindFury.mp3") end;
	end
end

function SW:CHAT_MSG_SPELL_AURA_GONE_SELF()
	if string.find(arg1,"Water Shield") then
		if self.db.profile.water then PlaySoundFile("Interface\\AddOns\\ShamanWarning\\Sounds\\Water.mp3") end;
	end
end

function SW:IsElemental()
	return self.db.profile.elemental;
end

function SW:ToggleElemental()
	self.db.profile.elemental = not self.db.profile.elemental;
end

function SW:IsWindfury()
	return self.db.profile.windfury;
end

function SW:ToggleWindfury()
	self.db.profile.windfury = not self.db.profile.windfury;
end

function SW:IsFlurry()
	return self.db.profile.flurry;
end

function SW:ToggleFlurry()
	self.db.profile.flurry = not self.db.profile.flurry;
end

function SW:IsStorm()
	return self.db.profile.storm;
end

function SW:ToggleStorm()
	self.db.profile.storm = not self.db.profile.storm;
end

function SW:IsWater()
	return self.db.profile.water;
end

function SW:ToggleWater()
	self.db.profile.water = not self.db.profile.water;
end

function SW:IsClearcast()
	return self.db.profile.clearcast;
end

function SW:ToggleClearcast()
	self.db.profile.clearcast = not self.db.profile.clearcast;
end
